SpringBoardParser Class Reference documentation

SpringBoardParser Class Referencefinal

the main class to read a SpringBoard v1 file More...

`#include <SpringBoardParser.hxx>`

Inheritance diagram for SpringBoardParser:

## Public Member Functions
| SpringBoardParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~SpringBoardParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGDrawingInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWGraphicParser
| ~MWAWGraphicParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | createDocument (librevenge::RVNGDrawingInterface *documentInterface)
| creates the listener which will be associated to the document
bool | parsePageNumbering (MWAWEntry const &entry)
| try to parse the page numbering zone
bool | parseDataList (int id, MWAWEntry const &entry)
| try to parse a list of data
bool | parseLastZone (int id, MWAWEntry const &entry)
| try to parse a second entry zones
bool | parseFrames (int page, long pos)
| try to parse a list of frames corresponding to a page
bool | parseData (int id, MWAWEntry const &entry, MWAWVec2i const &indices)
| try to parse some data
bool | parseParagraphStyle (MWAWEntry const &entry, MWAWVec2i const &indices)
| try to parse a list of paragraph style: zone8
bool | parseShape (long pos, std::pair< int, int > const &pageId)
| try to parse a shape
bool | createZones ()
| finds the different objects zones
bool | readFont (MWAWFont &font, int szFieldSize)
| try to read a font
bool | sendHeaderFooter (int hfId)
| try to send a header/footer text
bool | sendFrame (std::pair< int, int > const &pageId)
| try to send a frame (with a shape)
bool | sendTextShape (std::pair< int, int > const &pageId, int minParagraph=0, int maxParagraph=-1)
| try to send a shape text
bool | sendLinkShape (std::pair< int, int > const &linkId, bool isTop)
| try to send a link text
bool | isPositionValid (long pos) const
| returns true if the position is a valid file positions, ie.
bool | isEntryValid (MWAWEntry const &entry) const
| returns true if the zone is a valid zone positions, ie.
Protected Member Functions inherited from MWAWGraphicParser
| MWAWGraphicParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWGraphicParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< SpringBoardParserInternal::State > | m_state
| the state

## Friends
class | SpringBoardParserInternal::SubDocument

## Detailed Description

the main class to read a SpringBoard v1 file

## Constructor & Destructor Documentation

## ◆ SpringBoardParser()

SpringBoardParser::SpringBoardParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

Referenced by isEntryValid().

## ◆ ~SpringBoardParser()

SpringBoardParser::~SpringBoardParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool SpringBoardParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse(), and SpringBoardParserInternal::SubDocument.

## ◆ createDocument()

void SpringBoardParser::createDocument | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse(), and SpringBoardParserInternal::SubDocument.

## ◆ createZones()

bool SpringBoardParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse(), and SpringBoardParserInternal::SubDocument.

## ◆ isEntryValid()

bool SpringBoardParser::isEntryValid | ( | MWAWEntry const & | entry | ) | const
| protected

returns true if the zone is a valid zone positions, ie.

exists in the file and not in a already parsed zone

Referenced by createZones(), isPositionValid(), parseDataList(), and SpringBoardParserInternal::SubDocument.

## ◆ isPositionValid()

bool SpringBoardParser::isPositionValid | ( | long | pos | ) | const
| protected

returns true if the position is a valid file positions, ie.

exists in the file and not in a already parsed zone

Referenced by parseLastZone(), parseShape(), and SpringBoardParserInternal::SubDocument.

## ◆ parse()

void SpringBoardParser::parse | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWGraphicParser.

Referenced by SpringBoardParserInternal::SubDocument.

## ◆ parseData()

bool SpringBoardParser::parseData | ( | int | id,
|  | MWAWEntry const & | entry,
|  | MWAWVec2i const & | indices )
| protected

try to parse some data

Referenced by parseDataList(), and SpringBoardParserInternal::SubDocument.

## ◆ parseDataList()

bool SpringBoardParser::parseDataList | ( | int | id,
|  | MWAWEntry const & | entry )
| protected

try to parse a list of data

Referenced by createZones(), and SpringBoardParserInternal::SubDocument.

## ◆ parseFrames()

bool SpringBoardParser::parseFrames | ( | int | page,
|  | long | pos )
| protected

try to parse a list of frames corresponding to a page

Referenced by parseLastZone(), and SpringBoardParserInternal::SubDocument.

## ◆ parseLastZone()

bool SpringBoardParser::parseLastZone | ( | int | id,
|  | MWAWEntry const & | entry )
| protected

try to parse a second entry zones

Referenced by createZones(), and SpringBoardParserInternal::SubDocument.

## ◆ parsePageNumbering()

bool SpringBoardParser::parsePageNumbering | ( | MWAWEntry const & | entry | ) |
| protected

try to parse the page numbering zone

Referenced by createZones(), and SpringBoardParserInternal::SubDocument.

## ◆ parseParagraphStyle()

bool SpringBoardParser::parseParagraphStyle | ( | MWAWEntry const & | entry,
|  | MWAWVec2i const & | indices )
| protected

try to parse a list of paragraph style: zone8

Referenced by parseDataList(), and SpringBoardParserInternal::SubDocument.

## ◆ parseShape()

bool SpringBoardParser::parseShape | ( | long | pos,
|  | std::pair< int, int > const & | pageId )
| protected

try to parse a shape

Referenced by parseLastZone(), and SpringBoardParserInternal::SubDocument.

## ◆ readFont()

bool SpringBoardParser::readFont | ( | MWAWFont & | font,
|  | int | szFieldSize )
| protected

try to read a font

Referenced by parseData(), parsePageNumbering(), sendTextShape(), and SpringBoardParserInternal::SubDocument.

## ◆ sendFrame()

bool SpringBoardParser::sendFrame | ( | std::pair< int, int > const & | pageId | ) |
| protected

try to send a frame (with a shape)

Referenced by parse(), and SpringBoardParserInternal::SubDocument.

## ◆ sendHeaderFooter()

bool SpringBoardParser::sendHeaderFooter | ( | int | hfId | ) |
| protected

try to send a header/footer text

Referenced by SpringBoardParserInternal::SubDocument.

## ◆ sendLinkShape()

bool SpringBoardParser::sendLinkShape | ( | std::pair< int, int > const & | linkId,
|  | bool | isTop )
| protected

try to send a link text

Referenced by SpringBoardParserInternal::SubDocument.

## ◆ sendTextShape()

bool SpringBoardParser::sendTextShape | ( | std::pair< int, int > const & | pageId,
|  | int | minParagraph = 0,
|  | int | maxParagraph = -1 )
| protected

try to send a shape text

Referenced by SpringBoardParserInternal::SubDocument.

## Friends And Related Symbol Documentation

## ◆ SpringBoardParserInternal::SubDocument

friend class SpringBoardParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<SpringBoardParserInternal::State> SpringBoardParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), isEntryValid(), parse(), parseData(), parseDataList(), parseFrames(), parsePageNumbering(), parseParagraphStyle(), parseShape(), sendFrame(), sendHeaderFooter(), sendLinkShape(), sendTextShape(), and SpringBoardParser().

The documentation for this class was generated from the following files:

- SpringBoardParser.hxx
- SpringBoardParser.cxx